.\"	$NetBSD: statvfs.2,v 1.3 2004/04/21 21:25:59 kleink Exp $
.\"
.\" Copyright (c) 1989, 1991, 1993
.\"	The Regents of the University of California.  All rights reserved.
.\"
.\" Redistribution and use in source and binary forms, with or without
.\" modification, are permitted provided that the following conditions
.\" are met:
.\" 1. Redistributions of source code must retain the above copyright
.\"    notice, this list of conditions and the following disclaimer.
.\" 2. Redistributions in binary form must reproduce the above copyright
.\"    notice, this list of conditions and the following disclaimer in the
.\"    documentation and/or other materials provided with the distribution.
.\" 3. Neither the name of the University nor the names of its contributors
.\"    may be used to endorse or promote products derived from this software
.\"    without specific prior written permission.
.\"
.\" THIS SOFTWARE IS PROVIDED BY THE REGENTS AND CONTRIBUTORS ``AS IS'' AND
.\" ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
.\" IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
.\" ARE DISCLAIMED.  IN NO EVENT SHALL THE REGENTS OR CONTRIBUTORS BE LIABLE
.\" FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
.\" DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
.\" OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
.\" HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
.\" LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
.\" OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
.\" SUCH DAMAGE.
.\"
.\"	@(#)statfs.2	8.5 (Berkeley) 5/24/95
.\"
.Dd April 14, 2004
.Dt STATVFS 2
.Os
.Sh NAME
.Nm statvfs ,
.Nm statvfs1 ,
.Nm fstatvfs ,
.Nm fstatvfs1
.Nd get file system statistics
.Sh LIBRARY
.Lb libc
.Sh SYNOPSIS
.In sys/statvfs.h
.Ft int
.Fn statvfs "const char *path" "struct statvfs *buf"
.Ft int
.Fn statvfs1 "const char *path" "struct statvfs *buf" "int flags"
.Ft int
.Fn fstatvfs "int fd" "struct statvfs *buf"
.Ft int
.Fn fstatvfs1 "int fd" "struct statvfs *buf" "int flags"
.Sh DESCRIPTION
.Fn statvfs
and
.Fn statvfs1
return information about a mounted file system.
.Fa path
is the path name of any file within the mounted file system.
.Fa buf
is a pointer to a
.Nm statvfs
structure defined in
.Xr statvfs 5 .
.Pp
.Fn fstatvfs
and
.Fn fstatvfs1
return the same information about an open file referenced by descriptor
.Fa fd .
.Pp
The
.Fn statvfs1
and
.Fn fstatvfs1
functions allow an extra
.Fa flags
argument which can be
.Dv ST_WAIT
and
.Dv ST_NOWAIT .
When
.Dv ST_NOWAIT
is specified, then only cached statistics are returned.
This can result in significant savings on non-local filesystems, where
gathering statistics involves a network communication.
.Pp
The
.Fn statvfs
and
.Fn fstatvfs
calls are equivalent to the respective
.Fn statvfs1
and
.Fn fstatvfs1
calls with
.Dv ST_WAIT
specified as the
.Fa flags
argument.
.Sh RETURN VALUES
Upon successful completion, a value of 0 is returned.
Otherwise, \-1 is returned and the global variable
.Va errno
is set to indicate the error.
.Sh ERRORS
.Fn statvfs
and
.Fn statvfs1
fail if one or more of the following are true:
.Bl -tag -width Er
.It Bq Er ENOTDIR
A component of the path prefix of
.Fa path
is not a directory.
.It Bq Er ENAMETOOLONG
The length of a component of
.Fa path
exceeds
.Dv NAME_MAX
characters, or the length of
.Fa path
exceeds
.Dv PATH_MAX
characters.
.It Bq Er ENOENT
The file referred to by
.Fa path
does not exist.
.It Bq Er EACCES
Search permission is denied for a component of the path prefix of
.Fa path .
.It Bq Er ELOOP
Too many symbolic links were encountered in translating
.Fa path .
.It Bq Er EFAULT
.Fa buf
or
.Fa path
points to an invalid address.
.It Bq Er EIO
An
.Tn I/O
error occurred while reading from or writing to the file system.
.El
.Pp
.Fn fstatvfs
and
.Fn fstatvfs1
fail if one or more of the following are true:
.Bl -tag -width Er
.It Bq Er EBADF
.Fa fd
is not a valid open file descriptor.
.It Bq Er EFAULT
.Fa buf
points to an invalid address.
.It Bq Er EIO
An
.Tn I/O
error occurred while reading from or writing to the file system.
.El
.Sh SEE ALSO
.Xr statvfs 5
.Sh HISTORY
The
.Fn statvfs ,
.Fn statvfs1 ,
.Fn fstatvfs ,
and
.Fn fstatvfs1
functions first appeared in
.Nx 3.0
to replace
the
.Fn statfs
family of functions which first appeared in
.Bx 4.4 .
